package com.fp.persistence.pgeneral.acco;

import javax.persistence.Column;
import java.io.Serializable;
import com.fp.dto.hb.HibernateId;
import java.lang.reflect.Field;
import javax.persistence.Embeddable;
import javax.persistence.Transient;

/**Clase que hace referencia a la Clave Primaria de TGENEWARRANTYACCOUNT*/
@Embeddable
public class TgeneWarrantyAccountKey  extends com.fp.dto.AbstractDataTransport  implements Serializable,Cloneable,HibernateId{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
@Column(name="ACCOUNT", nullable=false,updatable=false)

/**
* No de Cuenta de un Prestamo o Linea de Credito
*/
private String account;

@Column(name="COMPANY", nullable=false,updatable=false)

/**
* Codigo de compania a la que pertence la cuenta del prestamo o linea de credito
*/
private Integer company;

@Column(name="WARRACCOUNT", nullable=false,updatable=false)

/**
* Numero de cuenta asociado a una garantia, si la misma garantia esta avalando mas de una operacion.
*/
private String warraccount;

@Column(name="WARRCOMPANY", nullable=false,updatable=false)

/**
* Codigo de compania a la que pertence la cuenta de la garantia.
*/
private Integer warrcompany;

/**Contructor por defecto*/
public TgeneWarrantyAccountKey(){}
/**Contructor de TgeneWarrantyAccountKey
@param pAccount No de Cuenta de un Prestamo o Linea de Credito
@param pCompany Codigo de compania a la que pertence la cuenta del prestamo o linea de credito
@param pWarraccount Numero de cuenta asociado a una garantia, si la misma garantia esta avalando mas de una operacion.
@param pWarrcompany Codigo de compania a la que pertence la cuenta de la garantia.
*/
public TgeneWarrantyAccountKey(String pAccount,Integer pCompany,String pWarraccount,Integer pWarrcompany){
 account=pAccount;
 company=pCompany;
 warraccount=pWarraccount;
 warrcompany=pWarrcompany;
}
/**Obtiene el valor de account
@return valor de account*/
public String getAccount(){
  return account;
}
/**Fija el valor de account
@param pAccount nuevo Valor de account*/
public void setAccount(String pAccount){
  account=pAccount;
}

/**Obtiene el valor de company
@return valor de company*/
public Integer getCompany(){
  return company;
}
/**Fija el valor de company
@param pCompany nuevo Valor de company*/
public void setCompany(Integer pCompany){
  company=pCompany;
}

/**Obtiene el valor de warraccount
@return valor de warraccount*/
public String getWarraccount(){
  return warraccount;
}
/**Fija el valor de warraccount
@param pWarraccount nuevo Valor de warraccount*/
public void setWarraccount(String pWarraccount){
  warraccount=pWarraccount;
}

/**Obtiene el valor de warrcompany
@return valor de warrcompany*/
public Integer getWarrcompany(){
  return warrcompany;
}
/**Fija el valor de warrcompany
@param pWarrcompany nuevo Valor de warrcompany*/
public void setWarrcompany(Integer pWarrcompany){
  warrcompany=pWarrcompany;
}

/**Implementación de la comparación de TgeneWarrantyAccountKey
@param o Objeto de comparación
*/
public boolean equals(Object o){
  if (o == null)return false;
  if (! (o instanceof TgeneWarrantyAccountKey))return false;
  TgeneWarrantyAccountKey that = (TgeneWarrantyAccountKey) o;
  if (this.getAccount() == null || that.getAccount() == null){
      return false;
  }
  if (! this.getAccount().equals(that.getAccount())){
    return false;
  }
  if (this.getCompany() == null || that.getCompany() == null){
      return false;
  }
  if (! this.getCompany().equals(that.getCompany())){
    return false;
  }
  if (this.getWarraccount() == null || that.getWarraccount() == null){
      return false;
  }
  if (! this.getWarraccount().equals(that.getWarraccount())){
    return false;
  }
  if (this.getWarrcompany() == null || that.getWarrcompany() == null){
      return false;
  }
  if (! this.getWarrcompany().equals(that.getWarrcompany())){
    return false;
  }
  return true;
}
/**Implementación del método hashCode bajo el patrón de Bloch
@return hashCode de la instancia TgeneWarrantyAccountKey
*/
public int hashCode(){
  if (this.hashValue == 0){
    int result = 17;
    result = result * 37 + (this.getAccount() == null ? 0 : this.getAccount().hashCode());
    result = result * 37 + (this.getCompany() == null ? 0 : this.getCompany().hashCode());
    result = result * 37 + (this.getWarraccount() == null ? 0 : this.getWarraccount().hashCode());
    result = result * 37 + (this.getWarrcompany() == null ? 0 : this.getWarrcompany().hashCode());
    this.hashValue = result;
  }
  return this.hashValue;
}
public Object cloneMe() throws CloneNotSupportedException {
  return this.clone();
}
/**Implementación toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+="pk."+name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
}
